Package ru.bitel.bgbilling.plugins.shop.common.service

# Interface WarehouseService

public interface WarehouseService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `deleteAttribute(int attributeId)`
  `void`
  `deleteAttributeKit(int attributeKitId)`
  `void`
  `deleteStockItem(int stockItemId)`
  `void`
  `deleteStockItemType(int stockItemTypeId)`
  `void`
  `deleteWarehouse(int warehouseId)`
  `StockItemAttributeKit`
  `getAttributeKit(int attributeKitId)`
  `List<StockItemAttributeKit>`
  `getAttributeKitList()`
  `List<StockItemAttribute>`
  `getAttributeList()`
  `List<StockItemAttributeValue>`
  `getAttributeValuesByStockItem(int stockItemId)`
  `int`
  `getCurrentUserId()`
  `StockItem`
  `getStockItemById(int stockItemId)`
  `StockItemType`
  `getStockItemType(int stockItemTypeId)`
  `List<StockItemType>`
  `getStockItemTypesByWarehouse(int warehouseId)`
  `StockItemType`
  `getStockItemTypeTreeRoot()`
  `Warehouse`
  `getWarehouse(int id)`
  `SearchResult<StockItem>`
  `getWarehouseItemsByType(int warehouseId, int stockItemTypeId, Page page)`
  Вернёт список товаров для указанного склада.
  `List<Warehouse>`
  `getWarehouseList()`
  `List<StockItem>`
  `searchStockItems(int warehouseId, int attributeId, String data)`
  Поиск товаров на складе
  `List<StockItemType>`
  `stockItemTypeList()`
  `StockItemAttribute`
  `updateAttribute(StockItemAttribute attribute)`
  `StockItemAttributeKit`
  `updateAttributeKit(StockItemAttributeKit attributeKit)`
  `StockItem`
  `updateStockItem(StockItem stockItem)`
  `StockItemType`
  `updateStockItemType(StockItemType stockItemType)`
  `Warehouse`
  `updateWarehouse(Warehouse warehouse)`

- ## Method Details

  - ### getWarehouseList

    List<Warehouse> getWarehouseList() throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getWarehouse

    Warehouse getWarehouse(int id) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateWarehouse

    Warehouse updateWarehouse(Warehouse warehouse) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteWarehouse

    void deleteWarehouse(int warehouseId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getStockItemById

    StockItem getStockItemById(int stockItemId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateStockItem

    StockItem updateStockItem(StockItem stockItem) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getWarehouseItemsByType

    SearchResult<StockItem> getWarehouseItemsByType(int warehouseId, int stockItemTypeId, Page page) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Вернёт список товаров для указанного склада.
    Parameters:
      `warehouseId` - ID склада
      `stockItemTypeId` - ID типа товаров указанного склада или invalid input: '<'=0, чтобы получить все товары склада всех типов
      `page` - null, если нужен весь список товаров склада
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteStockItem

    void deleteStockItem(int stockItemId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getStockItemType

    StockItemType getStockItemType(int stockItemTypeId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getStockItemTypeTreeRoot

    StockItemType getStockItemTypeTreeRoot() throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### stockItemTypeList

    List<StockItemType> stockItemTypeList() throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateStockItemType

    StockItemType updateStockItemType(StockItemType stockItemType) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteStockItemType

    void deleteStockItemType(int stockItemTypeId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getStockItemTypesByWarehouse

    List<StockItemType> getStockItemTypesByWarehouse(int warehouseId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Returns:
      вернет список типов товара, которые есть на складе
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getAttributeKitList

    List<StockItemAttributeKit> getAttributeKitList() throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getAttributeKit

    StockItemAttributeKit getAttributeKit(int attributeKitId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateAttributeKit

    StockItemAttributeKit updateAttributeKit(StockItemAttributeKit attributeKit) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteAttributeKit

    void deleteAttributeKit(int attributeKitId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateAttribute

    StockItemAttribute updateAttribute(StockItemAttribute attribute) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getAttributeList

    List<StockItemAttribute> getAttributeList() throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteAttribute

    void deleteAttribute(int attributeId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getAttributeValuesByStockItem

    List<StockItemAttributeValue> getAttributeValuesByStockItem(int stockItemId) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getCurrentUserId

    int getCurrentUserId() throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### searchStockItems

    List<StockItem> searchStockItems(int warehouseId, int attributeId, String data) throws Exception, ru.bitel.bgbilling.common.BGMessageException
    Поиск товаров на складе
    Parameters:
      `warehouseId` - id склада по которому будет поиск
      `attributeId` - id аттрибута в значении которого будем искать
      `data` - введённые пользователем данные для поиска
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGMessageException`